
#ifndef bcap_common_utils_h
#define bcap_common_utils_h


#include <click/config.h>
#include "fastpass_endhost.hh"
#include <click/confparse.hh>
#include <click/error.hh>
#include <click/router.hh>
#include <click/standard/scheduleinfo.hh>
#include <click/glue.hh>
#include <clicknet/ip.h>

#include "fastpass_common.hh"

void print_capability(secflow_capability *cap) 
{
  click_chatter("ID = %d  Pri = %d CurRouter = %d \n",
	 cap->id, cap->prioclass, cap->cur_router);
  click_chatter("[0 = %x ] [ 1 = %x ] [ 2 = %x ] [ 3 = %x ]\n",
	 cap->markings[0].marking, cap->markings[1].marking,
	 cap->markings[2].marking, cap->markings[3].marking);
  click_chatter("[4 = %x ] [ 5 = %x ] [ 6 = %x ] [ 7 = %x ]\n",
	 cap->markings[4].marking, cap->markings[5].marking,
	 cap->markings[6].marking, cap->markings[7].marking);
      
}

void print_secflow_hdr(hdr_secflow* hdr) 
{
  click_chatter("------  Cap Current  --------\n");
  print_capability(&(hdr->cap_current));
  click_chatter("------  Cap Next -------- \n");
  print_capability(&(hdr->cap_next));
  click_chatter("-------  Cap Reply -------- \n");
  print_capability(&(hdr->cap_reply));
}




#endif
