#ifndef secflow_receiver_h
#define secflow_receiver_h

#include "fastpass_common.hh"
//#include "cap_timer.h"

#define SECFLOW_GRANTER_ACK_TIMEOUT 200 //in ms

typedef struct t_secflow_granter{
  u8 has_cap_reply; //flag indicating if we have a capability to send back 
  secflow_capability latest_cap_reply; // most recent capability to return
//  secflow_timer timer; // timer to make sure we have returned a capability recently?
  u32 app_grant_class; //max class the application will grant
  u8 no_timer; // bool to tell if there is a timer set or not
 // spinlock_t granter_lock; // lock to protect the granter
}secflow_granter;


void granter_init(secflow_granter* granter);
void granter_process_hdr(secflow_granter* granter, hdr_secflow *hdr);	
void granter_initialize_hdr(secflow_granter* granter, hdr_secflow *hdr);
void granter_timeout(unsigned long data);
void granter_cleanup(secflow_granter* granter);
void granter_grant_class(secflow_granter *granter, u8 c);

#endif
