#ifndef cap_requester_h
#define cap_requester_h

#include "fastpass_common.hh"
//#include "cap_timer.h"

// dw: to be honest, i don't really understand the differences between these two 
// timeout values yet.(1/12/06)

// in msecs, takes care of actual timeouts when we have not received anything
// back.  We respond by lowering the requested class.  
#define SECFLOW_REQUESTER_TIMEOUT 1000

// in msecs, keeps track of when we will have to send another packet
// with the request flag
#define SECFLOW_REQ_TIMEOUT 100 

typedef struct t_secflow_requester{
  secflow_capability latest_cap; // most recent capability we have acquired
  u32 requesting_class;	// class currently being requested in the capability request
  u32 app_req_class; //max class desired by application
  //secflow_timer timer;	// timer to handle capability request timeouts
  u8 first_req_4_cur_class; // flag telling if we are requesting a class for the first time
  u32 newid; // id of the new capability being requested
  //spinlock_t requester_lock; // lock protecting this requester
  struct timeval next_req_time; // time to request next capability

}secflow_requester;

// See .c file for function comments
void requester_init(secflow_requester* requester);
void requester_initialize_hdr(secflow_requester* requester, hdr_secflow *hdr);  
void requester_process_hdr(secflow_requester* requester, hdr_secflow *hdr);
void requester_set_req_class(secflow_requester* requester, u8 reqclass);
void requester_timeout(unsigned long data);
void requester_cleanup(secflow_requester* requester);

#endif 
