
#ifndef CLICK_SECFLOW_HH
#define CLICK_SECFLOW_HH
#include <click/element.hh>
#include <click/string.hh>
#include <clicknet/ip.h>
#include <click/timer.hh>
#include "fastpass_common.hh"
#include "secflow_router_marking.hh"
#include "token_validate.hh"

#define offset_in_page(p) ((unsigned long)(p) & ~PAGE_MASK)

class FastPassRouter: public Element { 

public:
  FastPassRouter();
  ~FastPassRouter();
  
  int initialize(ErrorHandler *);
  
  const char *class_name() const		{ return "FastPassRouter"; }
  const char *processing() const		{ return PUSH; }
  int configure(Vector<String> &, ErrorHandler *);
  bool can_live_reconfigure() const		{ return true; }
  
  void push(int i, Packet *p);  
  void run_timer();

 private:
  
  int num_pub_keys;
  pubkey_info pub_keys[128];
  unsigned _protocol;		// Protocol number assigned to SIFF 
  Timer keytimer;
  SecflowRouterMarking marking_handler;  
};

#endif

