#ifndef _fp_thruput_test_sink_hh
#define _fp_thruput_test_sink_hh

#include <click/element.hh>
#include <click/gaprate.hh>
#include <click/packet.hh>
#include <click/atomic.hh>
#include <clicknet/udp.h>
#include <click/timer.hh>
#include <click/standard/alignmentinfo.hh>
#include <click/glue.hh>
#include <click/hashmap.hh>
#include <click/bighashmap.hh>
#include <click/vector.hh>


class FPThroughputTestSink : public Element {

public:

	FPThroughputTestSink();
	~FPThroughputTestSink();

	int initialize(ErrorHandler *);
	void run_timer();
	const char *class_name() const { return "FPThroughputTestSink"; }
	const char *processing() const { return PUSH; }
	int configure(Vector<String> &, ErrorHandler *);
	bool can_live_reconfigure() const { return true; }
	void push(int i, Packet *p);

  	Timer _timer;
	unsigned int timer_interval; 
	u_int _num_req, _num_data;

	u_short _last_data_len;
}; 

#endif
