#ifndef _fp_thruput_test_source_hh
#define _fp_thruput_test_source_hh

#include <click/element.hh>
#include <click/gaprate.hh>
#include <click/packet.hh>
#include <click/atomic.hh>
#include <clicknet/udp.h>
#include <click/timer.hh>
#include <click/standard/alignmentinfo.hh>
#include <click/glue.hh>
#include <click/hashmap.hh>
#include <click/bighashmap.hh>
#include <click/vector.hh>


class FPThroughputTestSource : public Element {

public:

	FPThroughputTestSource();
	~FPThroughputTestSource();

  	IPAddress _src;
  	IPAddress _dst;
	int initialize(ErrorHandler *);
	void run_timer();
	const char *class_name() const { return "FPThroughputTestSource"; }
	const char *processing() const { return PUSH; }
	int configure(Vector<String> &, ErrorHandler *);
	bool can_live_reconfigure() const { return true; }
        void add_handlers();        

	WritablePacket *_request_packet, *_data_packet;
	GapRate _req_rate, _data_rate;
  	Timer _timer;
	unsigned int timer_interval; 
private: 

	static int request_rate_write_handler
             (const String &conf, Element *e, void *, ErrorHandler *errh);
        static int data_rate_write_handler
             (const String &conf, Element *e, void *, ErrorHandler *errh);

        static int data_size_write_handler
             (const String &conf, Element *e, void *, ErrorHandler *errh);

}; 

#endif
