#include <click/config.h>
#include <click/glue.hh>
#include <click/confparse.hh>
#include <click/error.hh>
#include <click/straccum.hh>
#include <clicknet/ip.h>
#include <clicknet/tcp.h>
#ifdef CLICK_LINUXMODULE
#include <click/cxxprotect.h>
#include <linux/highmem.h>
#include <linux/skbuff.h>
#include <linux/netdevice.h>
#include <linux/ip.h>
CLICK_CXX_PROTECT 
#include <linux/sched.h>
CLICK_CXX_UNPROTECT 
#include <click/cxxunprotect.h>
#endif
CLICK_DECLS

#include <click/packet_anno.hh>
#include "fp_token_req_test.hh"
#include "fp_test_utils.hh"
#include "fastpass_common.hh"
#include "time_utils.h"

FPTokenReqTest::FPTokenReqTest() : Element(0,1), _timer(this)
{
	MOD_INC_USE_COUNT;
	_token_requester = new TokenRequester();
}

FPTokenReqTest::~FPTokenReqTest() 
{
	MOD_DEC_USE_COUNT;
}

int FPTokenReqTest::configure(Vector<String> &conf,
	ErrorHandler *errh) 
{
	return 0;
}
  
int FPTokenReqTest::initialize(ErrorHandler *e) 
{
	timer_interval = TIMER_INTERVAL_MSEC; 
  	_timer.initialize(this);
  	_timer.schedule_after_ms(timer_interval);
	return 0;
}

void
FPTokenReqTest::run_timer()
{
   IPAddress saddr = IPAddress("10.1.4.2");
   IPAddress token_server = IPAddress("10.1.4.7");
   IPAddress target = IPAddress("10.1.2.2");
   click_chatter("sending token request for: %s \n", 
		target.unparse().c_str());
   Packet *p = _token_requester->createRequest(
			target.addr(), saddr.addr(), token_server.addr());
   output(0).push(p);
  _timer.schedule_after_ms(timer_interval);
}


CLICK_ENDDECLS
EXPORT_ELEMENT(FPTokenReqTest)
