#ifndef _fp_token_req_test_hh
#define _fp_token_req_test_hh

#include <click/element.hh>
#include <click/gaprate.hh>
#include <click/packet.hh>
#include <click/atomic.hh>
#include <clicknet/udp.h>
#include <click/timer.hh>
#include <click/standard/alignmentinfo.hh>
#include <click/glue.hh>
#include <click/hashmap.hh>
#include <click/bighashmap.hh>
#include <click/vector.hh>
#include "fastpass_endhost.hh" // for TokenType
#include "token_req.hh"


#define TIMER_INTERVAL_MSEC	1000

class FPTokenReqTest : public Element {

public:

	FPTokenReqTest();
	~FPTokenReqTest();

	int initialize(ErrorHandler *);
	void run_timer();
	const char *class_name() const { return "FPTokenReqTest"; }
	const char *processing() const { return PUSH; }
	int configure(Vector<String> &, ErrorHandler *);
	bool can_live_reconfigure() const { return true; }

  	Timer _timer;
	unsigned int timer_interval; 
 	TokenRequester* _token_requester;	

}; 

#endif
