#ifndef _fp_ttc_test_sink_hh
#define _fp_ttc_test_sink_hh

#include <click/element.hh>
#include <click/gaprate.hh>
#include <click/packet.hh>
#include <click/atomic.hh>
#include <clicknet/udp.h>
#include <click/timer.hh>
#include <click/standard/alignmentinfo.hh>
#include <click/glue.hh>
#include <click/hashmap.hh>
#include <click/bighashmap.hh>
#include <click/vector.hh>


class FPTTCTestSink : public Element {

public:

	FPTTCTestSink();
	~FPTTCTestSink();

	int initialize(ErrorHandler *);
	void run_timer();
	const char *class_name() const { return "FPTTCTestSink"; }
	const char *processing() const { return PUSH; }
	int configure(Vector<String> &, ErrorHandler *);
	bool can_live_reconfigure() const { return true; }
	void push(int i, Packet *p);

  	Timer _timer;
	unsigned int timer_interval; 
	int _num_attack, _num_legit;
}; 

#endif
