#ifndef _token_store_h_
#define _token_store_h_

#include "fastpass_common.hh"
#include <click/string.hh>
#include <click/bighashmap.hh>
#include <click/vector.hh>
#ifdef CLICK_LINUXMODULE
#include <linux/in.h>
#endif

class TokenStore {

public : 

static const int NO_TOKEN_FOUND = -1;

TokenStore();
~TokenStore();

int get_bogus_token(char *buf);
int get_token(u_int dest_ip, char* buf, bool remove);
void print_all_tokens();
int add_token(String tok_str);
u_int get_last_loaded_dest() { return _last_loaded_dest; }

private: 
  u_int _last_loaded_dest;
  HashMap<u_int, Vector< bcap_token_hdr*> >  _token_map;
};

#endif
