#include <click/config.h>
#include <click/glue.hh>
#include <click/confparse.hh>
#include <click/error.hh>
#include <click/straccum.hh>

#ifdef CLICK_LINUXMODULE
#include <click/cxxprotect.h>
#include <linux/highmem.h>
#include <linux/skbuff.h>
#include <linux/netdevice.h>
#include <linux/ip.h>
CLICK_CXX_PROTECT 
#include <linux/sched.h>
CLICK_CXX_UNPROTECT 
#include <click/cxxunprotect.h>
#endif
CLICK_DECLS

#include <click/packet_anno.hh>
#include "tva_token_handler.hh"



TVATokenHandler::TVATokenHandler() : Element(1,2)
{
	MOD_INC_USE_COUNT;
}

TVATokenHandler::~TVATokenHandler() 
{
	MOD_DEC_USE_COUNT;
}

int TVATokenHandler::configure(Vector<String> &conf,
	ErrorHandler *errh) 
{
	int n = noutputs();
	if(cp_va_parse(conf, this, errh,
			cpOptional,
			cpUnsigned, "num output queues",
			&n, cpEnd) < 0)
	return -1;  // error if num outputs not given

	set_noutputs(n);
	return 0;
}
  
int TVATokenHandler::initialize(ErrorHandler *e) 
{
	return 0;
}

void TVATokenHandler::push(int i, Packet *p) {
	// userspace only for now!
	int color = PAINT_ANNO(p);

	if(color < 0 || color >= noutputs() ) {
		click_chatter("tva token handler has impossible color %d \n",
		color);
		return;
	}
	output(color).push(p); // put in correct DRR queue
	
}

CLICK_ENDDECLS
EXPORT_ELEMENT(TVATokenHandler)
