#!/usr/bin/perl -w

use strict;
use IO::Socket;
use Time::Local;
 
# change this to change how long token is valid
my $token_valid_len_msec = 5000;

if($#ARGV != 0) {
        die " must provide the server port as the only paramter \n";
}

if(!(-e "token_util")) {
	die "Error: you must have the 'token_util' binary in the same directory";
}

my ($client,$fp_server,$token_file);

$fp_server = IO::Socket::INET->new
(
LocalPort => $ARGV[0],
Type => SOCK_STREAM,
Reuse => 1,
Listen => 200 # client queue
) or die "Error: couldn't open server. Was port value valid? Are you root?";


my $ipaddr = "10.1.1.2";

while ($client = $fp_server->accept()) {

	my $rand = int( rand(10000000) );
	my $time = time + $token_valid_len_msec; 
	my $request = <$client>; # read only first line
	# split on the '/' to get the requested IP
	print "request = '$request' \n";
	if($request =~ /\b((\d{1,3}\.){3}\d{1,3})\b/) {
	
		print "requesting token for: '$1' \n";
		my $result = `./token_util t $rand $time $1 priv.db`;
#	print $result . "\n";
		print $client $result;
	} else {
		print $client "Did not find an IP address in request";
	}
	close $client;
}


