#include <iostream.h>
#include <fstream.h>
#include "token_validate.hh"
#include "token_generate.hh"

int
main (int argc, char **argv)
{

  pubkey_info pub_keys[128];
  privkey_info priv_keys[128];

   if(argc < 2 || argc > 6) {
     printf("options:\n");
     printf("g <priv.p> <priv.q> <pub> [generate new key files]\n");
     printf("t <i> <t> <dst-ip> <privkey.DB> [create a new token] \n");
     printf("v <pubkey.DB> <token file> [to verify the current token] \n");
     printf("d <ip-list> <pubkey.DB> <privkey.DB> [generate new key databases] \n");
     printf("b <binary file> [prints file byte-by-byte ] \n");
     printf("r <key size> <num verifies> <num signatures> [benchmark rabin] \n");
     printf("n <pubkey.DB> <token file> [verify token w/new file format]\n");
     return 0;
   }

   if(argv[1][0] == 'g') {
     generate_key(argv[2], argv[3], argv[4]);

   }else if(argv[1][0] == 't') {
     struct in_addr addr;
     int noerror = inet_aton(argv[4], &addr); 
     if(!noerror) {
       printf("invalid ip address '%s' \n", argv[4]);
       return 1;
     }
     int num_keys = load_private_keys(argv[5], priv_keys, 128);
     generate_token(atoi(argv[2]), atoi(argv[3]), addr, priv_keys , num_keys);

   }else if(argv[1][0] == 'v') {
     int num_keys = load_public_keys(argv[2], pub_keys, 128);
     validate_token_file(pub_keys, num_keys, argv[3]);
   }else if(argv[1][0] == 'n') {
     int num_keys = load_public_keys(argv[2], pub_keys, 128);
     validate_new_token_file(pub_keys, num_keys, argv[3]);


   } else if (argv[1][0] == 'd') {
     generate_new_key_DB(argv[2], argv[3], argv[4]);
   } else if (argv[1][0] == 'b') {

	ifstream file(argv[2]);
	file.seekg(0, ios::end);
	int length = file.tellg();
	file.seekg(0, ios::beg);

	char* buf = new char[length];
	file.read(buf, length);
	bcap_print_bytes(buf, length);
	file.close();
	delete[] buf;	
  }else if (argv[1][0] == 'r') {
	rabin_benchmark(atoi(argv[2]), atoi(argv[3]), atoi(argv[4]));
  }
  return 0;

}
